diff --git isisd/isis_spf.c isisd/isis_spf.c
index 5d7e9da..6e53601 100644
--- isisd/isis_spf.c
+++ isisd/isis_spf.c
@@ -1303,51 +1493,174 @@ isis_spf_schedule6 (struct isis_area *area, int level)
 }
 #endif
 
+#ifdef HAVE_TRILL
+static int
+trill_complete_spf(struct isis_area *area)
+{
+  int retval;
+  dnode_t *dnode;
+  nicknode_t *tnode;
+
+  retval = isis_run_spf (area, TRILL_ISIS_LEVEL, AF_TRILL, isis->sysid, NULL);
+  if (retval != ISIS_OK)
+    zlog_warn ("ISIS-Spf running spf for system returned:%d", retval);
+
+  /* 
+   * Run SPF for all other RBridges in the campus as well to
+   * compute the distribution trees with other RBridges in
+   * the campus as root. 
+   */
+  for (ALL_DICT_NODES_RO(area->trill->nickdb, dnode, tnode))
+    {
+      retval = isis_run_spf (area, TRILL_ISIS_LEVEL, AF_TRILL,
+	                tnode->info.sysid, tnode->rdtree);
+      if (isis->debugs & DEBUG_SPF_EVENTS)
+        zlog_debug ("ISIS-Spf running spf for:%s",
+                        print_sys_hostname (tnode->info.sysid));
+      if (retval != ISIS_OK)
+        zlog_warn ("ISIS-Spf running spf for:%s returned:%d",
+                        print_sys_hostname (tnode->info.sysid), retval);
+    }
+
+  /* 
+   * Process computed SPF trees to create TRILL 
+   * forwarding and adjacency tables.
+   */
+  trill_process_spf (area);
+  return retval;
+}
+
+static int
+isis_run_spf_trill (struct thread *thread)
+{
+  struct isis_area *area;
+  int retval;
+
+  area = THREAD_ARG (thread);
+  assert (area);
+
+  area->spftree[0]->t_spf = NULL;
+
+  if (!(area->is_type & IS_LEVEL_1))
+    {
+      if (isis->debugs & DEBUG_SPF_EVENTS)
+	zlog_warn ("ISIS-SPF (%s) area does not share level", area->area_tag);
+      return ISIS_WARNING;
+    }
+
+  if (isis->debugs & DEBUG_SPF_EVENTS)
+    zlog_debug ("ISIS-Spf (%s) L1 SPF needed, periodic SPF", area->area_tag);
+
+  retval = trill_complete_spf(area);
+
+  THREAD_TIMER_ON (master, area->spftree[0]->t_spf, isis_run_spf_trill, area,
+		   isis_jitter (PERIODIC_SPF_INTERVAL, 10));
+
+  return retval;
+}
+
+int
+isis_spf_schedule_trill (struct isis_area *area)
+{
+  int retval = ISIS_OK;
+  struct isis_spftree *spftree = area->spftree[TRILL_ISIS_LEVEL - 1];
+  time_t diff, now = time (NULL);
+
+  if (spftree->pending)
+    return retval;
+
+  diff = now - spftree->lastrun;
+
+  /* FIXME: let's wait a minute before doing the SPF */
+  if (now - isis->uptime < 60 || isis->uptime == 0)
+    {
+      THREAD_TIMER_ON (master, spftree->t_spf, isis_run_spf_trill, area, 60);
+
+      spftree->pending = 1;
+      return retval;
+    }
+
+  THREAD_TIMER_OFF (spftree->t_spf);
+
+  if (diff < MINIMUM_SPF_INTERVAL)
+    {
+      THREAD_TIMER_ON (master, spftree->t_spf, isis_run_spf_trill, area,
+		       MINIMUM_SPF_INTERVAL - diff);
+
+      spftree->pending = 1;
+    }
+  else
+    {
+      spftree->pending = 0;
+
+      retval = trill_complete_spf(area);
+
+      THREAD_TIMER_ON (master, spftree->t_spf, isis_run_spf_trill, area,
+		       isis_jitter (PERIODIC_SPF_INTERVAL, 10));
+    }
+
+  return retval;
+}
+#endif /* HAVE_TRILL */
+
 static void
-isis_print_paths (struct vty *vty, struct list *paths)
+isis_print_paths (struct vty *vty, struct list *paths, u_char *root_sysid)
 {
   struct listnode *node;
+  struct listnode *cnode;
   struct isis_vertex *vertex;
-  struct isis_dynhn *dyn, *nh_dyn = NULL;
+  struct isis_vertex *cvertex;
   struct isis_adjacency *adj;
 #if 0
   u_char buff[255];
 #endif /* 0 */
 
   vty_out (vty, "System Id            Metric     Next-Hop"
-	   "             Interface   SNPA%s", VTY_NEWLINE);
+	   "             Interface     SNPA        Tree%s", VTY_NEWLINE);
 
   for (ALL_LIST_ELEMENTS_RO (paths, node, vertex))
     {
-      if (vertex->type != VTYPE_NONPSEUDO_IS)
+      if (vertex->type != VTYPE_NONPSEUDO_IS &&
+	  vertex->type != VTYPE_NONPSEUDO_TE_IS)
 	continue;
-      if (memcmp (vertex->N.id, isis->sysid, ISIS_SYS_ID_LEN) == 0)
+      if (memcmp (vertex->N.id, root_sysid, ISIS_SYS_ID_LEN) == 0)
 	{
-	  vty_out (vty, "%s             --%s", host.name?host.name:"",
-		   VTY_NEWLINE);
+	  vty_out (vty, "%-20s %-10s", print_sys_hostname (root_sysid), "--");
+	  vty_out (vty, "%-48s", "");
 	}
       else
 	{
-	  dyn = dynhn_find_by_id ((u_char *) vertex->N.id);
-	  adj = listgetdata (listhead (vertex->Adj_N));
-	  if (adj)
+	  if (listhead (vertex->Adj_N) &&
+	       (adj = listgetdata (listhead (vertex->Adj_N))))
 	    {
-	      nh_dyn = dynhn_find_by_id (adj->sysid);
-	      vty_out (vty, "%-20s %-10u %-20s %-11s %-5s%s",
-		       (dyn != NULL) ? dyn->name.name :
-		       (const u_char *)rawlspid_print ((u_char *) vertex->N.id),
-		       vertex->d_N, (nh_dyn != NULL) ? nh_dyn->name.name :
-		       (const u_char *)rawlspid_print (adj->sysid),
+	      vty_out (vty, "%-20s %-10u %-20s %-11s %-8s",
+                       print_sys_hostname (vertex->N.id),
+		       vertex->d_N, print_sys_hostname (adj->sysid),
 		       adj->circuit->interface->name,
-		       snpa_print (adj->snpa), VTY_NEWLINE);
+		       snpa_print (adj->snpa));
 	    }
 	  else
 	    {
-	      vty_out (vty, "%s              %u %s", dyn ? dyn->name.name :
-		       (const u_char *) rawlspid_print (vertex->N.id),
-		       vertex->d_N, VTY_NEWLINE);
+	      vty_out (vty, "%-20s %-10u %-48s ", 
+		      print_sys_hostname (vertex->N.id), 
+		      vertex->d_N, "");
 	    }
 	}
+
+      if (vertex->parent)
+        vty_out (vty, " %s(%d) :-> ",
+		print_sys_hostname (vertex->parent->N.id), vertex->type);
+      else
+        vty_out (vty, " :> ");
+
+      if (listcount (vertex->children) > 0)
+        {
+          for (ALL_LIST_ELEMENTS_RO (vertex->children, cnode, cvertex))
+	    vty_out (vty, "%s(%d),", 
+	         print_sys_hostname(cvertex->N.id), cvertex->type);
+	}
+      vty_out (vty, "%s", VTY_NEWLINE);
+
 #if 0
       vty_out (vty, "%s %s %u %s", vtype2string (vertex->type),
 	       vid2string (vertex, buff), vertex->d_N, VTY_NEWLINE);
@@ -1355,6 +1668,26 @@ isis_print_paths (struct vty *vty, struct list *paths)
     }
 }
 
+#ifdef HAVE_TRILL
+static void
+trill_print_paths (struct vty *vty, struct isis_area *area)
+{
+  dnode_t *dnode;
+  nicknode_t *tnode;
+
+  for (ALL_DICT_NODES_RO(area->trill->nickdb, dnode, tnode))
+  {
+    if (tnode->rdtree && tnode->rdtree->paths->count > 0)
+    {
+      vty_out (vty, "%sRBridge distribution paths for RBridge:%s%s",
+       	       VTY_NEWLINE, print_sys_hostname (tnode->info.sysid),
+	       VTY_NEWLINE);
+      isis_print_paths (vty, tnode->rdtree->paths, tnode->info.sysid);
+    }
+  }
+}
+#endif /* HAVE_TRILL */
+
 DEFUN (show_isis_topology,
        show_isis_topology_cmd,
        "show isis topology",
@@ -1381,7 +1714,7 @@ DEFUN (show_isis_topology,
 	    {
 	      vty_out (vty, "IS-IS paths to level-%d routers that speak IP%s",
 		       level + 1, VTY_NEWLINE);
-	      isis_print_paths (vty, area->spftree[level]->paths);
+	      isis_print_paths (vty, area->spftree[level]->paths, isis->sysid);
 	    }
 #ifdef HAVE_IPV6
 	  if (area->ipv6_circuits > 0 && area->spftree6[level]
@@ -1390,10 +1723,15 @@ DEFUN (show_isis_topology,
 	      vty_out (vty,
 		       "IS-IS paths to level-%d routers that speak IPv6%s",
 		       level + 1, VTY_NEWLINE);
-	      isis_print_paths (vty, area->spftree6[level]->paths);
+	      isis_print_paths (vty, area->spftree6[level]->paths, isis->sysid);
 	    }
 #endif /* HAVE_IPV6 */
 	}
+
+#ifdef HAVE_TRILL
+      if (isis->trill_active)
+	trill_print_paths (vty, area);
+#endif
     }
 
   return CMD_SUCCESS;
@@ -1423,7 +1761,7 @@ DEFUN (show_isis_topology_l1,
 	{
 	  vty_out (vty, "IS-IS paths to level-1 routers that speak IP%s",
 		   VTY_NEWLINE);
-	  isis_print_paths (vty, area->spftree[0]->paths);
+	  isis_print_paths (vty, area->spftree[0]->paths, isis->sysid);
 	}
 #ifdef HAVE_IPV6
       if (area->ipv6_circuits > 0 && area->spftree6[0]
@@ -1431,9 +1769,13 @@ DEFUN (show_isis_topology_l1,
 	{
 	  vty_out (vty, "IS-IS paths to level-1 routers that speak IPv6%s",
 		   VTY_NEWLINE);
-	  isis_print_paths (vty, area->spftree6[0]->paths);
+	  isis_print_paths (vty, area->spftree6[0]->paths, isis->sysid);
 	}
 #endif /* HAVE_IPV6 */
+#ifdef HAVE_TRILL
+      if (isis->trill_active)
+	trill_print_paths (vty, area);
+#endif
     }
 
   return CMD_SUCCESS;
@@ -1463,7 +1805,7 @@ DEFUN (show_isis_topology_l2,
 	{
 	  vty_out (vty, "IS-IS paths to level-2 routers that speak IP%s",
 		   VTY_NEWLINE);
-	  isis_print_paths (vty, area->spftree[1]->paths);
+	  isis_print_paths (vty, area->spftree[1]->paths, isis->sysid);
 	}
 #ifdef HAVE_IPV6
       if (area->ipv6_circuits > 0 && area->spftree6[1]
@@ -1471,7 +1813,7 @@ DEFUN (show_isis_topology_l2,
 	{
 	  vty_out (vty, "IS-IS paths to level-2 routers that speak IPv6%s",
 		   VTY_NEWLINE);
-	  isis_print_paths (vty, area->spftree6[1]->paths);
+	  isis_print_paths (vty, area->spftree6[1]->paths, isis->sysid);
 	}
 #endif /* HAVE_IPV6 */
     }
diff --git isisd/isis_spf.h isisd/isis_spf.h
index 6bdab2d..ece9896 100644
--- isisd/isis_spf.h
+++ isisd/isis_spf.h
@@ -54,11 +54,12 @@ struct isis_vertex
     struct prefix prefix;
   } N;
 
-  struct isis_lsp *lsp;
+  struct isis_lsp *lsp;         /* referring LSP (the LSP this vertex was learnt from) */
   u_int32_t d_N;		/* d(N) Distance from this IS      */
   u_int16_t depth;		/* The depth in the imaginary tree */
-
-  struct list *Adj_N;		/* {Adj(N)}  */
+  struct list *Adj_N;		/* {Adj(N)} next hop or neighbor list */
+  struct isis_vertex *parent;   /* parent and child links used to find adjacencies on tree */
+  struct list *children;
 };
 
 struct isis_spftree
@@ -72,10 +73,16 @@ struct isis_spftree
   u_int32_t timerun;		/* statistics */
 };
 
+struct isis_spftree * isis_spftree_new (void);
+void isis_spftree_del (struct isis_spftree *spftree);
 void spftree_area_init (struct isis_area *area);
+void spftree_area_del (struct isis_area *area);
 int isis_spf_schedule (struct isis_area *area, int level);
 void isis_spf_cmds_init (void);
 #ifdef HAVE_IPV6
 int isis_spf_schedule6 (struct isis_area *area, int level);
 #endif
+#ifdef HAVE_TRILL
+int isis_spf_schedule_trill (struct isis_area *area);
+#endif
 #endif /* _ZEBRA_ISIS_SPF_H */
diff --git isisd/isis_tlv.c isisd/isis_tlv.c
index 94fa65e..0690243 100644
--- isisd/isis_tlv.c
+++ isisd/isis_tlv.c
@@ -43,13 +43,6 @@
 #include "isisd/isis_pdu.h"
 #include "isisd/isis_lsp.h"
 
-extern struct isis *isis;
-
-/*
- * Prototypes.
- */
-int add_tlv (u_char, u_char, u_char *, struct stream *);
-
 void
 free_tlv (void *val)
 {
@@ -93,7 +86,10 @@ free_tlvs (struct tlvs *tlvs)
   if (tlvs->ipv6_reachs)
     list_delete (tlvs->ipv6_reachs);
 #endif /* HAVE_IPV6 */
-  
+  if (tlvs->router_capabilities)
+    list_delete (tlvs->router_capabilities);
+  if (tlvs->port_capabilities)
+    list_delete (tlvs->port_capabilities);
   return;
 }
 
@@ -714,6 +710,28 @@ parse_tlvs (char *areatag, u_char * stream, int size, u_int32_t * expected,
 	  pnt += length;
 	  break;
 
+        case ROUTER_CAPABILITY:
+	  /* +------+------+------+------+------+-------+
+	   * |Length|          Router ID        | Flags |
+	   * +------+------+------+------+------+-------+
+	   * |    optional sub-TLVs (0-250 octets)      |
+	   * +------+------+------+------+------+-------+
+	   */
+	  *found |= TLVFLAG_ROUTER_CAPABILITY;
+	  if (tlvs->router_capabilities == NULL)
+              tlvs->router_capabilities = list_new ();
+	  listnode_add (tlvs->router_capabilities, (pnt - 1));
+	  pnt += length;
+	  break;
+
+        case PORT_CAPABILITY:
+	  *found |= TLVFLAG_PORT_CAPABILITY;
+	  if (tlvs->port_capabilities == NULL)
+	      tlvs->port_capabilities  = list_new ();
+	  listnode_add (tlvs->port_capabilities, (pnt - 1));
+	  pnt += length;
+	  break;
+
 	default:
 	  zlog_warn ("ISIS-TLV (%s): unsupported TLV type %d, length %d",
 		     areatag, type, length);
@@ -731,7 +749,8 @@ int
 add_tlv (u_char tag, u_char len, u_char * value, struct stream *stream)
 {
 
-  if (STREAM_SIZE (stream) - stream_get_endp (stream) < (unsigned) len + 2)
+  if (STREAM_SIZE (stream) - stream_get_endp (stream) <
+      (unsigned) len + TLFLDS_LEN)
     {
       zlog_warn ("No room for TLV of type %d", tag);
       return ISIS_WARNING;
@@ -739,7 +758,8 @@ add_tlv (u_char tag, u_char len, u_char * value, struct stream *stream)
 
   stream_putc (stream, tag);	/* TAG */
   stream_putc (stream, len);	/* LENGTH */
-  stream_put (stream, value, (int) len);	/* VALUE */
+  if (len > 0)
+    stream_put (stream, value, (int) len);	/* VALUE */
 
 #ifdef EXTREME_DEBUG
   zlog_debug ("Added TLV %d len %d", tag, len);
@@ -747,6 +767,52 @@ add_tlv (u_char tag, u_char len, u_char * value, struct stream *stream)
   return ISIS_OK;
 }
 
+/*
+ * Add a subTLV to an existing TLV.  Returns ISIS_ERROR if it can't fit in the
+ * stream at all.  Returns ISIS_WARNING if it doesn't fit in the current TLV
+ * (but may fit in another one).
+ */
+int
+add_subtlv (u_char tag, u_char len, u_char * value, size_t tlvpos,
+    struct stream *stream)
+{
+  unsigned newlen;
+
+  /* Compute new outer TLV length */
+  newlen = stream_getc_from(stream, tlvpos + 1) + (unsigned) len + TLFLDS_LEN;
+
+  /* Check if it's possible to fit the subTLV in the stream at all */
+  if (STREAM_SIZE (stream) - stream_get_endp (stream) <
+      (unsigned) len + TLFLDS_LEN ||
+      len > 255 - TLFLDS_LEN)
+    {
+      zlog_debug ("No room for subTLV %d len %d", tag, len);
+      return ISIS_ERROR;
+    }
+
+  /* Check if it'll fit in the current TLV */
+  if (newlen > 255)
+    {
+#ifdef EXTREME_DEBUG
+      /* extreme debug only, because repeating TLV is usually possible */
+      zlog_debug ("No room for subTLV %d len %d in TLV %d", tag, len,
+		  stream_getc_from(stream, tlvpos));
+#endif /* EXTREME DEBUG */
+      return ISIS_WARNING;
+    }
+
+  stream_putc (stream, tag);	/* TAG */
+  stream_putc (stream, len);	/* LENGTH */
+  stream_put (stream, value, (int) len);	/* VALUE */
+  stream_putc_at (stream,  tlvpos + 1, newlen);
+
+#ifdef EXTREME_DEBUG
+  zlog_debug ("Added subTLV %d len %d to TLV %d", tag, len,
+	      stream_getc_from(stream, tlvpos));
+#endif /* EXTREME DEBUG */
+  return ISIS_OK;
+}
+
 int
 tlv_add_area_addrs (struct list *area_addrs, struct stream *stream)
 {
diff --git isisd/isis_tlv.h isisd/isis_tlv.h
index fc9f35f..f421627 100644
--- isisd/isis_tlv.h
+++ isisd/isis_tlv.h
@@ -60,6 +60,7 @@
  * P2P Adjacency State      240   y   n   n  RFC3373
  * IIH Sequence Number      241   y   n   n  draft-shen-isis-iih-sequence
  * Router Capability        242   -   -   -  draft-ietf-isis-caps
+ * Port Capability	    243   n   y   n  draft-eastlake-trill-bridge-isis
  *
  * 
  * IS Reachability sub-TLVs we (should) support.
@@ -85,6 +86,28 @@
  * 32bit administrative tag           1   draft-ietf-isis-admin-tags
  * 64bit administrative tag           2   draft-ietf-isis-admin-tags
  * Management prefix color          117   draft-ietf-isis-wg-multi-topology
+ *
+ *
+ * Router Capability sub-TLVs we support (Values TBD, temporary for now).
+ * ____________________________________________________________________________
+ * Name                           Value   Status
+ * ____________________________________________________________________________
+ * TRILL Flags			     21	  draft-ietf-trill-rbridge-protocol
+ * TRILL Nickname and Tree Root	     22	  draft-ietf-trill-rbridge-protocol
+ * TRILL Distribution Tree Roots     23	  draft-ietf-trill-rbridge-protocol
+ * TRILL VLANs and Bridge Roots	     24	  draft-ietf-trill-rbridge-protocol
+ * TRILL ESADI Participation	     25	  draft-ietf-trill-rbridge-protocol
+ * TRILL VLAN Groups		     26	  draft-ietf-trill-rbridge-protocol
+ * TRILL VLAN Mapping		     27	  draft-ietf-trill-rbridge-protocol
+ *
+ *
+ * Port Capability sub-TLVs we support
+ * ____________________________________________________________________________
+ * Name                           Value   Status
+ * ____________________________________________________________________________
+ * TRILL Special VLANs and Flags     10	  draft-ietf-trill-rbridge-protocol
+ * TRILL Enabled VLANs		     11	  draft-ietf-trill-rbridge-protocol
+ * TRILL Appointed Forwarders	     12	  draft-ietf-trill-rbridge-protocol
  */
 
 #define AREA_ADDRESSES            1
@@ -109,12 +132,44 @@
 #define IPV6_ADDR                 232
 #define IPV6_REACHABILITY         236
 #define WAY3_HELLO                240
+#define ROUTER_CAPABILITY	  242
+#define PORT_CAPABILITY		  243   /* TBD TRILL port capability TLV */
+
+/* ROUTER_CAPABILITY sub-TLVs for TRILL */
+#define	RCSTLV_TRILL_FLAGS	  21	/* TBD Flags */
+#define RCSTLV_TRILL_NICKNAME	  22	/* TBD Nickname and Tree Root */
+#define RCSTLV_TRILL_TREE_ROOTS	  23	/* TBD Distribution Tree Roots */
+#define RCSTLV_TRILL_VLANSROOTS	  24	/* TBD VLANs and Bridge Roots */
+#define RCSTLV_TRILL_ESADI	  25	/* TBD ESADI Participation */
+#define RCSTLV_TRILL_VLANGROUPS	  26	/* TBD VLAN Groups */
+#define RCSTLV_TRILL_VLANMAPPING  27	/* TBD VLAN Mapping */
+
+/* PORT_CAPABILITY sub-TLVs for TRILL */
+#define PCSTLV_VLANS		  10	/* Special VLANs and Flags */
+#define PCSTLV_ENABLEDVLANS	  11	/* Enabled VLANs */
+#define PCSTLV_APPFORWARDERS	  12	/* Appointed Forwarders */
 
 #define IS_NEIGHBOURS_LEN (ISIS_SYS_ID_LEN + 5)
 #define LAN_NEIGHBOURS_LEN 6
 #define LSP_ENTRIES_LEN (10 + ISIS_SYS_ID_LEN)	/* FIXME: should be entry */
 #define IPV4_REACH_LEN 12
 #define IPV6_REACH_LEN 22
+#define TLFLDS_LEN 2			         /* Length of Type & Len 8-bit fields */	
+#define ROUTER_CAPABILITY_MIN_LEN  5		 /* Min len of router capability TLV */
+#define ROUTER_CAPABILITY_MAX_LEN  250 		 /* Max len of router capability TLV */
+
+/* TRILL Flags sub-TLV */
+#define TRILL_FLAGS_SUBTLV_MIN_LEN 1 		 /* Len of sub-TLV val */
+#define	TRILL_FLAGS_V0	0x80
+#define	TRILL_FLAGS_V1	0x40
+#define	TRILL_FLAGS_V2	0x20
+#define	TRILL_FLAGS_V3	0x10
+
+#define TRILL_NICKNAME_SUBTLV_MIN_LEN 7 	 /* Len of TRILL nickname sub-TLV value field */
+#define TRILL_VLANSNBRIROOTS_SUBTLV_MIN_LEN 4    /* Len of variable len TRILL VLANs and Bridge Roots sub-TLV value field */
+#define PCSTLV_VLANS_LEN	 4		 /* Exact len of port capability VLANs sub-TLV */
+#define PCSTLV_VLANFWDERS_MIN_LEN 6		 /* Min. len of each appointed forwarders sub-TLV */
+#define PCSTLV_ENABLEDVLANS_MIN_LEN 3		 /* Min. len of enabled VLANS sub-TLV */
 
 /* struct for neighbor */
 struct is_neigh
@@ -131,6 +186,15 @@ struct te_is_neigh
   u_char sub_tlvs_length;
 };
 
+/* Decode and encode three-octet metric into host byte order integer */
+#define GET_TE_METRIC(t) \
+  (((unsigned)(t)->te_metric[0]<<16) | ((t)->te_metric[1]<<8) | \
+   (t)->te_metric[2])
+#define SET_TE_METRIC(t, m) \
+  (((t)->te_metric[0] = (m) >> 16), \
+   ((t)->te_metric[1] = (m) >> 8), \
+   ((t)->te_metric[2] = (m)))
+
 /* struct for es neighbors */
 struct es_neigh
 {
@@ -213,7 +277,6 @@ struct ipv6_reachability
   u_char prefix_len;
   u_char prefix[16];
 };
-#endif /* HAVE_IPV6 */
 
 /* bits in control_info */
 #define CTRL_INFO_DIRECTION    0x80
@@ -223,6 +286,92 @@ struct ipv6_reachability
 #define DISTRIBUTION_INTERNAL  0
 #define DISTRIBUTION_EXTERNAL  1
 #define CTRL_INFO_SUBTLVS      0x20
+#endif /* HAVE_IPV6 */
+
+/* internal trill nickname struct */
+struct trill_nickname
+{
+  u_int16_t name;		/* network byte order */
+  u_int8_t priority;
+};
+
+/* Router Capability TLV: used in LSPs */
+struct router_capability_tlv
+{
+  u_char router_id[4];		   /* 4 octet Router ID */
+  u_int8_t flags;		   /* 1 octet flags */
+};
+
+/* internal router capability struct, includes tlv length */
+struct router_capability
+{
+  u_int8_t len;  		/* total length of the TLV */
+  struct router_capability_tlv rt_cap_tlv;
+};
+
+/* Port Capability TLV: used in Hellos */
+struct port_capability_tlv
+{
+  u_int8_t len;
+  u_int8_t value[1];
+};
+
+#ifdef __SUNPRO_C
+#pragma pack(1)
+#endif
+
+/* LSP: ROUTER_CAPABILITY RCSTLV_TRILL_NICKNAME */
+struct trill_nickname_subtlv
+{
+    u_int8_t tn_priority;
+    u_int16_t tn_nickname;
+    u_int16_t tn_trootpri;
+    u_int16_t tn_treecount;
+} __attribute__ ((packed));
+
+#ifdef __SUNPRO_C
+#pragma pack()
+#endif
+
+/* LSP: ROUTER_CAPABILITY RCSTLV_TRILL_VLANSROOTS */
+struct trill_vlan_bridge_roots_subtlv
+{
+    u_int16_t vlan_start;
+    u_int16_t vlan_end;
+};
+
+/* flags for vlan_start */
+#define	TVRFS_M4	0x8000
+#define	TVRFS_M6	0x4000
+#define	TVRFS_OM	0x2000
+#define	TVRFS_R		0x1000
+
+/* Hello: PORT_CAPABILITY PCSTLV_VLANS */
+struct trill_vlanflags_subtlv
+{
+    u_int16_t outer_vlan;
+    u_int16_t desig_vlan;
+};
+
+/* flags for outer_vlan */
+#define	TVFFO_AF	0x8000
+#define	TVFFO_AC	0x4000
+#define	TVFFO_VM	0x2000
+#define	TVFFO_R		0x1000
+
+/* Hello: PORT_CAPABILITY PCSTLV_APPFORWARDERS */
+struct appointed_vlanfwder_subtlv
+{
+    u_int16_t appointee_nick;
+    u_int16_t vlan_start;
+    u_int16_t vlan_end;
+};
+
+/* Hello: PORT_CAPABILITY PCSTLV_ENABLEDVLANS */
+struct trill_enabledvlans_subtlv
+{
+    u_int16_t start_vlan;
+};
 
 /*
  * Pointer to each tlv type, filled by parse_tlvs()
@@ -249,6 +398,8 @@ struct tlvs
   struct list *ipv6_reachs;
 #endif
   struct isis_passwd auth_info;
+  struct list *router_capabilities;
+  struct list *port_capabilities;
 };
 
 /*
@@ -277,6 +428,8 @@ struct tlvs
 #define TLVFLAG_TE_ROUTER_ID              (1<<19)
 #define TLVFLAG_CHECKSUM                  (1<<20)
 #define TLVFLAG_GRACEFUL_RESTART          (1<<21)
+#define TLVFLAG_ROUTER_CAPABILITY         (1<<22)
+#define TLVFLAG_PORT_CAPABILITY	          (1<<23)
 
 void init_tlvs (struct tlvs *tlvs, uint32_t expected);
 void free_tlvs (struct tlvs *tlvs);
@@ -284,6 +437,11 @@ int parse_tlvs (char *areatag, u_char * stream, int size,
 		u_int32_t * expected, u_int32_t * found, struct tlvs *tlvs);
 void free_tlv (void *val);
 
+int add_tlv (u_char, u_char, u_char *, struct stream *);
+int add_subtlv (u_char, u_char, u_char *, size_t, struct stream *);
+
+int tlv_add_trill_nickname (struct trill_nickname *nick_info, struct stream *stream,
+		struct isis_area *area);
 int tlv_add_area_addrs (struct list *area_addrs, struct stream *stream);
 int tlv_add_is_neighs (struct list *is_neighs, struct stream *stream);
 int tlv_add_te_is_neighs (struct list *te_is_neighs, struct stream *stream);
@@ -304,6 +462,7 @@ int tlv_add_ipv6_addrs (struct list *ipv6_addrs, struct stream *stream);
 int tlv_add_ipv6_reachs (struct list *ipv6_reachs, struct stream *stream);
 #endif /* HAVE_IPV6 */
 
+int tlv_add_trill_vlans(struct isis_circuit *);
 int tlv_add_padding (struct stream *stream);
 
 #endif /* _ZEBRA_ISIS_TLV_H */
